clear
clc

pval = [0.1 0.05 0.01];
rval = [-0.9 -0.5 0 0.5 0.9];

m1 = 1;
m2 = 1;

options = optimset('display','off','TolFun',1e-12,'TolX',1e-12);

samp = 1e6;

Names = {'010-010','010-005','010-001','005-010','005-005','005-001','001-010','001-005','001-001'};

for i = 1:length(pval)
    
    pvalb = pval(i);
    fpvb = @(b) pv(m1,b) - pvalb;
    s1 = fsolve(fpvb, m1/2, options);
    
    for j = 1:length(pval)
        
        pvalc = pval(j);
        fpvc = @(c) pv(m1,c) - pvalc;
        s2 = fsolve(fpvc, m2/2, options);
        
        for k = 1:length(rval)
            
            r = rval(k);

            
            %   set(gcf,'DefaultAxesColorOrder',[0 0 1;1 0 0;0 1 0]);
            %   set(gcf,'Units','normal');
            RatioDraw(m1,m2,s1,s2,r,-0.5,2.5);
            %   set(gca,'YLim',[0 1.3])
            %   xlabel('sC/uC');
            %   ylabel('sB/uB');
            hold all
            
        end
        
        hold off
        set(gca,'Position',[.03 .05 .94 .93]);
        set(gcf, 'Color', 'w')
        l1 = legend( mat2str(rval(1)), mat2str(rval(2)), mat2str(rval(3)), mat2str(rval(4)), mat2str(rval(5)) );
        v1 = get(l1,'title');
        set(v1,'string','Correlation coefficients:');
        set(l1, 'Position', [.75,.65,.15,.01]);
        %   title({['p-value of B = ' mat2str(pvalb)]; ['p-value of C = ' mat2str(pvalc)]})
        set(gca,'YTickLabelMode','Manual')
        set(gca, 'YTick', [])
        %   legend(rval);
        saveas(gcf,char(Names((i-1)*3+j)),'png')
        figure
        
    end
end
