clear
clc

pval = [0.1 0.05 0.01];
rval = [-0.9 -0.5 0 0.5 0.9];

m1 = 1;
m2 = 1;

options = optimset('display','off','TolFun',1e-12,'TolX',1e-12);

samp = 1e8;

no = 1;

% fcn = @(x) tcdf(x,Inf) - 0.975;
% t = fsolve(fcn, 1.645, options);
% z = norminv(0.975,0,1);
% t-z;

z0 = norminv(0.975,0,1);
t0 = z0;

RES = zeros(length(pval),length(pval),length(rval),16);


for i = 1:length(pval)
    
    pvalb = pval(i);
    fpvb = @(b) pv(m1,b) - pvalb;
    s1 = fsolve(fpvb, m1/2, options);
    
    line_i = zeros(length(pval),length(rval),16);
    
    for j = 1:length(pval)
        
        pvalc = pval(j);
        fpvc = @(c) pv(m1,c) - pvalc;
        s2 = fsolve(fpvc, m2/2, options);
        
        line_j = zeros(length(rval),16);
        
        parfor k = 1:length(rval)
            r = rval(k);
            B0 = [m1, m2];
            V0 = [s1^2 r*s1*s2; r*s1*s2 s2^2];
            cr = V0(1,2);
            Bsim0 = mvnrnd(B0,V0,samp);
            BC0 = Bsim0(:,1)./Bsim0(:,2);
            med = median(BC0);
            psm = mean(BC0);
            mod = mode(BC0);
            pssd = std(BC0);
            dsd = (m2.^(-4).*((-2).*cr.*m1.*m2+m2.^2.*s1.^2+m1.^2.*s2.^2))^0.5;
            q025d = m1/m2 - z0*dsd;
            q975d = m1/m2 + z0*dsd;
            q025 = quantile(BC0,0.025);
            q975 = quantile(BC0,0.975);
%             q025f_tmp = [(-1).*(m2.^2+(-1).*s2.^2.*t0.^2).^(-1).*((-1).*m1.*m2+cr.*t0.^2+( ...
%                 t0.^2.*((-2).*cr.*m1.*m2+m2.^2.*s1.^2+cr.^2.*t0.^2+s2.^2.*(m1.^2+( ...
%                 -1).*s1.^2.*t0.^2))).^(1/2))];
%             q975f_tmp = [(m2.^2+(-1).*s2.^2.*t0.^2).^(-1).*(m1.* ...
%                 m2+(-1).*cr.*t0.^2+(t0.^2.*((-2).*cr.*m1.*m2+m2.^2.*s1.^2+cr.^2.* ...
%                 t0.^2+s2.^2.*(m1.^2+(-1).*s1.^2.*t0.^2))).^(1/2))];
%             q025f_tmp = q025f_tmp*isreal(q025f_tmp);
%             q975f_tmp = q975f_tmp*isreal(q975f_tmp);
%             q025f = min(q025f_tmp, q975f_tmp);
%             q975f = max(q025f_tmp, q975f_tmp);
%             Fposit = (-1).*m2.^2+s2.^2.*t0.^2; % g^2 coefficient, if < 0 - interval is bounded
%             x_tmp = -(2.*m1.*m2+(-2).*cr.*t0.^2) / (2*((-1).*m2.^2+s2.^2.*t0.^2));
%             Dposit = (-1).*m1.^2+s1.^2.*t0.^2+x_tmp.*(2.*m1.*m2+(-2).*cr.*t0.^2)+x_tmp.^2.*((-1).*m2.^2+s2.^2.*t0.^2);
%             line(k,:) = [pvalb, pvalc, r, 1, psm, med, pssd, dsd, q025,q975,q025d,q975d,q025f,q975f, Fposit, Dposit];
%             line_j(k,:) = [pvalb, pvalc, r, 1, psm, med, pssd, dsd, q025,q975,q025d,q975d,q025f,q975f, Fposit, Dposit];
            [a1,a2,a3,a4] = RatioFiellerBounds(m1,m2,s1,s2,r);
            line_j(k,:) = [pvalb, pvalc, r, 1, psm, med, pssd, dsd, q025,q975,q025d,q975d,a1,a2,a3,a4];
            
        end
        
        line_i(j,:,:) = line_j;
        
    end
    
    RES(i,:,:,:) = line_i; % pval x pval x rval x results
    
end

RES = reshape(RES,[length(pval)*length(pval)*length(rval),size(RES,4)]);
RES = sortrows(RES,[1,2,3])
