clear
clc

m1 = 1;
m2 = 1;
pvalb = 0.05;
pvalc = 0.05;

options = optimset('display','off','TolFun',1e-12,'TolX',1e-12);

fpvb = @(b) pv(m1,b) - pvalb;
s1 = fsolve(fpvb, m1/2, options);
fpvc = @(c) pv(m1,c) - pvalc;
s2 = fsolve(fpvc, m2/2, options);
rval = [0.5];
B0 = [m1, m2];
V0 = [s1^2 rval*s1*s2; rval*s1*s2 s2^2];

samples = [1e2 1e3 1e4 1e5 1e6 1e7 1e8];

RES = NaN(length(samples)+3,6);

RES(1,4) = RatioQuantile(m1,m2,s1,s2,rval,0.5);
RES(1,5) = RatioQuantile(m1,m2,s1,s2,rval,0.225);
RES(1,6) = RatioQuantile(m1,m2,s1,s2,rval,0.975);

z0 = norminv(0.975,0,1);
dsd = (m1^2/m2^4*s2^2 + 1/m2^2*s1^2 - 2*m1/m2^3*V0(1,2))^0.5;
RES(2,2) = 1;
RES(2,3) = dsd;
RES(2,4) = 1;
RES(2,5) = 1-z0*dsd;
RES(2,6) = 1+z0*dsd;

rng(15485863);
Bsim0 = mvnrnd(B0,V0,samples(end));
BC0 = Bsim0(:,1)./Bsim0(:,2);

for m = 1:length(samples)
    psm = mean(BC0(1:samples(m)));
    pssd = std(BC0(1:samples(m)));
    med = median(BC0(1:samples(m)));
    q025 = quantile(BC0(1:samples(m)),0.025);
    q975 = quantile(BC0(1:samples(m)),0.975);
    
    RES(m+2,:) = [samples(m), psm, pssd, med, q025, q975];
end

RES(end,2) = 1;
RES(end,4) = 1;
[a1,a2,a3,a4] = RatioFiellerBounds(m1,m2,s1,s2,rval);
RES(end,5) = a2;
RES(end,6) = a3;
